rm(list = ls())

"A"<-function(x, a)
  #A(x,a) function for the scale parameter of the Weibull dist. of Y (duration)
  # x: vector of covariates (currently 2)
  # a: vector of parameters
{
  a0<-a[1]
  a1<-a[2]
  a2<-a[3]
  x1<-x[1]
  x2<-x[2]
  a0+ a1*x1 +a2*x2
}

"Ab"<-function(x, a)
  #A(x,a) function for the scale parameter of the Weibull dist. of Y (duration)
  # x: vector of covariates (currently 2)
  # a: vector of parameters
{
  a0<-a[1]
  a1<-a[2]
  
  x1<-x[1]
  
  a0+ a1*x1 
}

"Bb"<-function(X, b)
  #B(x,a) function for the scale parameter of the Weibull dist. of Y (duration)
  # x: vector of covariates (currently 2)
  # a: vector of parameters
{
  b0<-b[1]
  b1 <-b[2]
  b2<-b[3]
   
  x1<-x[1]
  
  b0+ b1*x1 +  b2*x1^2  
}

"SimpsonInt"<- function(xin, h)
{   #xin = data, h=distance of the points at which function is evaluated
  n<-length(xin)
  nn<-1:n
  int0<-xin[1]
  int2n<-xin[n]
  inteven<-xin[seq(3,n-1,by=2)]
  intodd<-xin[seq(2,n-2,by=2)]
  sumodd<-sum(intodd)
  sumeven<-sum(inteven)
  res<-(h/3)*(int0+4*sumodd+2*sumeven+int2n)
  res
}



"IntEpanechnikov"<-function(x)
{
  ifelse(x< -2.236068, 0, ifelse(x> 2.236068, 1, .5- (2.236068*x*(x^2-15))/100))
}

"IntUnif"<-function(x)
{
  ifelse(abs(x)< 1, 0.5*(x+1), ifelse(x> 1, 1, 0))
}

"Hstar"<-function(xin, cens, xout)
{
  ordxin <- sort(xin) #order input data=Xi
  ordcens <- cens[order(xin)] #order censoring =Di
  n <- length(xin)
  nn <- length(xout)
  vKuse <- sapply(1:nn, function (i, ordxin, xout) max(c(max(which(ordxin <= xout[i]))
                                                         , min(which(xout[i] <= ordxin)))), ordxin, xout)
  vK <- vKuse - 1
  Huse<-sapply(vK, function (i,n,ordcens) ((n-1:i+1)/(n-1:i+2))^(1-ordcens[1:i]), n, ordcens)
  result<-sapply(Huse, prod)
  result 
}

 

"csfe"<-function(yin, xin, yout, xout, h, b, kfun, wfun, cens)
{
  n<- length(xin)
  arg1<-(sapply(xout, "-", xin))/h  
  arg2<-kfun(arg1) 
  
  arg3<-(sapply(yout, "-", yin))/b  
  arg3.1 <-  cens /Hstar(yin,   1- cens, yin) #was 1-cens!!!
  
  arg4<-wfun(arg3)* arg3.1
  
  #cat( "arg4 = ",  round(arg4,3) , "\n length = ",  length(arg4), " ",length(arg3.1), " ", length(arg3), "\n")
  #tmp<-survfit(Surv(yin, cens) ~ 1)$surv
   #cat(" KM(surv) = ",  round(tmp,3) , "\n")
    #plot(yin, Hstar(yin,    1-cens, yin))
  # lines(sort(yin), tmp, type="p", col=2) 
    arg2222<-matrix(arg4, nrow=nrow(arg4), ncol=ncol(arg4))
   # cat(" KM(surv) = ",  round(arg2222[,1],3) , "\n")  
    #lines( yin, arg2222[,1], type="p", col=3) 
  
   #prmatrix(arg2222)
    arg2222<-matrix(arg4, nrow=nrow(arg4), ncol=ncol(arg4))
   arg2<-matrix(arg2, nrow=nrow(arg4), ncol=ncol(arg4))
  arg5<- arg2 * arg2222# arg4
  colSums(arg5)/n
}

"csfebiv"<-function(yin, xin, yout, xout, h, b, kfun, wfun, cens)
{
  n<- nrow(xin)
  xin1<-xin[,1]
  xin2<-xin[,2]
  xout1<-xout[,1]
  xout2<-xout[,2]
  h1<-h[1]
  h2<-h[2]
  
  arg1.1<-  (sapply(xout1, "-", xin1))/h1
  arg2.1<-kfun(arg1.1)
  
  arg1.2<-      (sapply(xout2, "-", xin2))/h2
  arg2.2<-kfun(arg1.2)
  
  arg3<-   (sapply(yout, "-", yin))/b
  arg3.1 <- cens/Hstar(yin, 1-cens, yin)
  arg4<-wfun(arg3)* arg3.1
  arg2.1<-matrix(arg2.1, nrow=nrow(arg4), ncol=ncol(arg4))
  arg2.2<-matrix(arg2.2, nrow=nrow(arg4), ncol=ncol(arg4))
  arg5<- arg2.1 *arg2.2   *arg4
  #arg7 <- tcrossprod(    arg5,arg4)
  colSums(arg5)/n
  #arg7/n
}

True.Surv<-function(x, y, d, a)
{
  
  exp( - Ab(x, a) * y^d)
}

set.seed(3)
a<-c(1,5)
y<-seq(0, 3, length=20)
x<-seq(0, 1, length=20)

#yyy<-seq(min(y), max(y), length=50)
xxx<-seq(min(x), max(x), length=20)
 d<-2
 n<-100
 Censoring<-rep(1, times=n)
 Censoring[sample(1:n, 10)]<-0
mat.out<-matrix(nrow = length(y) , ncol = length(xxx) )
########################
###MODELS S1, B1 version 1
#par(mar=c(1 ,1,1,1))
mat.out2<-matrix(nrow = length(y) , ncol = length(xxx) )
# MODEL S1:
for(i in 1: length(xxx))
{
  xi<-x[i]
  
  xxx<-seq(min(xi), max(xi), length=20)
  mat.out[,i]<- True.Surv(xxx,  y, d, a) #1- csfe(Duration, Amount, yyy, xxx[i],  bw.SJ(Amount), 3,  pnorm, IntEpanechnikov, Censoring)
  Duration<-rweibull(n,  d, Ab(xi, a)^{-1/d}) #random sample in y direction
  Amount<-runif(n)
  mat.out2[,i]<-  1-csfe(Duration, Amount, y, xxx[i],   4*bw.SJ(Amount),  bw.SJ(Duration)/2,  dnorm, IntEpanechnikov, Censoring)
  cat("est = ", round(mat.out2[,i], 3), " x location =", xi, "\n")
  cat("tru = ", round(mat.out[,i], 3), " x location =", xi, "\n")
}

means.use<- vector("numeric", length=length(xxx)) 
for(i in 1:length(xxx))
{
  means.use[i] <- SimpsonInt((mat.out[,i]-mat.out2[,i])^2, y[2]-y[1])
}
MISE.use <- mean(means.use)
MISE.use
  

persp(x=y, y=x, z=mat.out,  theta =  20, phi =  20, xlab="Duration", ylab="x", zlab="Survival", ticktype = "detailed")
persp(x=y, y=x, z=mat.out2,  theta =  20, phi =  20, xlab="Duration", ylab="x", zlab="Survival", ticktype = "detailed")
#plot(y, 1-pweibull(y, 2, 1), type="l")